<?php
/**
 * @package SEO ALRP
 * @version 0.110323
 */
/*
Plugin Name: SEO Auto Links & Related Posts
Plugin URI: http://exclusivewordpress.com/seo-auto-links-related-posts/
Author: Purwedi Kurniawan
Author URI: http://exclusivewordpress.com
Version: 0.110323
Description:  SEO Auto Links & Related Posts, a combination of related posts plugin and auto links plugin. The auto links feature will automatically convert related posts title and meta keyword into internal link. <a href="options-general.php?page=seo-alrp">Configure...</a>
*/
/**
 * install and uninstall seo-alrp plugin
**/
register_activation_hook(__file__,'pk_seo_alrp_admin_activation');
register_deactivation_hook(__file__,'pk_seo_alrp_admin_deactivation');
function pk_seo_alrp_admin_activation(){
	global $wpdb;
    $wpdb->hide_errors();
    $wpdb->query('ALTER TABLE '.$wpdb->posts.' ENGINE = MYISAM;');
    $wpdb->query('ALTER TABLE '.$wpdb->posts.' ADD FULLTEXT seo_alrp (post_title, post_content);');
    $wpdb->query('ALTER TABLE '.$wpdb->posts.' ADD FULLTEXT seo_alrp_title (post_title);');
    $wpdb->query('ALTER TABLE '.$wpdb->posts.' ADD FULLTEXT seo_alrp_content (post_content);');
    $wpdb->show_errors();
 	$options = seo_alrp_get_admin_options();
}
function pk_seo_alrp_admin_deactivation(){
	global $wpdb;
    $wpdb->hide_errors();
	$wpdb->query('ALTER TABLE '.$wpdb->posts.' DROP INDEX seo_alrp');
	$wpdb->query('ALTER TABLE '.$wpdb->posts.' DROP INDEX seo_alrp_title');
	$wpdb->query('ALTER TABLE '.$wpdb->posts.' DROP INDEX seo_alrp_content');
    $wpdb->show_errors();	
}
/**
 * load translation file
 **/ 
add_action('init', 'pk_seo_alrp_load_translation_file');
function pk_seo_alrp_load_translation_file() {
	$plugin_path = plugin_basename( dirname( __FILE__ ) );
	load_plugin_textdomain( 'seo-alrp', '', $plugin_path );
}
/**
 * add new menu into WordPress admin menu
**/ 
add_action('admin_menu','pk_seo_alrp_admin_menu_hook');
function pk_seo_alrp_admin_menu_hook(){
    if (function_exists('add_options_page')) {
		add_options_page(
			'SEO Auto Links &amp; Related Posts',
			'SEO ALRP',
			'manage_options',
			'seo-alrp',
			'pk_seo_alrp_admin_menu'
		);
	}
}

/**
 * Init plugin options to white list our options
 **/
add_action('admin_init', 'pk_seo_alrp_options_init' );
function pk_seo_alrp_options_init(){
	register_setting( 'seo-alrp', 'seo_alrp_options', 'pk_seo_alrp_validate_options' ); 
}

/** 
 * Sanitize and validate input. Accepts an array, return a sanitized array. 
 **/
function pk_seo_alrp_validate_options($input) {
	if(!empty($input['al_enabled'])) $input['al_enabled'] = intval($input['al_enabled']) == 1 ? 1 : 0 ;
	if(!empty($input['al_limit'])) $input['al_limit'] = intval($input['al_limit']); 
	if(!empty($input['al_match_limit'])) $input['al_match_limit'] = intval($input['al_match_limit']);
	if(!empty($input['al_meta_keyword'])) $input['al_meta_keyword'] = intval($input['al_meta_keyword']) == 1 ? 1 : 0 ;
	if(!empty($input['al_link_title'])) $input['al_link_title'] = addslashes($input['al_link_title']);
	if(!empty($input['al_manual_link'])) $input['al_manual_link'] = addslashes($input['al_manual_link']);
	if(!empty($input['rl_enabled'])) $input['rl_enabled'] = intval($input['rl_enabled']) == 1 ? 1 : 0 ;	
	if(!empty($input['rl_limit'])) $input['rl_limit'] = intval($input['rl_limit']);
	if(!empty($input['rl_exc_cat'])) $input['rl_exc_cat'] = addslashes($input['rl_exc_cat']);
	if(!empty($input['rl_on_pages'])) $input['rl_on_pages'] = intval($input['rl_on_pages']) == 1 ? 1 : 0 ;
	if(!empty($input['rl_add_content'])) $input['rl_add_content'] = intval($input['rl_add_content']) == 1 ? 1 : 0 ;
	if(!empty($input['rl_add_feed'])) $input['rl_add_feed'] = intval($input['rl_add_feed']) == 1 ? 1 : 0 ;	
	if(!empty($input['rl_match_content'])) $input['rl_match_content'] = intval($input['rl_match_content']) == 1 ? 1 : 0 ;
	if(!empty($input['rl_title'])) $input['rl_title'] = addslashes($input['rl_title']);
	if(!empty($input['rl_blank_output'])) $input['rl_blank_output'] = addslashes($input['rl_blank_output']);
	if(!empty($input['rl_excerpt'])) $input['rl_excerpt'] = intval($input['rl_excerpt']) == 1 ? 1 : 0 ;
	if(!empty($input['rl_excerpt_len'])) $input['rl_excerpt_len'] = intval($input['rl_excerpt_len']);
	if(!empty($input['rl_404_limit'])) $input['rl_404_limit'] = intval($input['rl_404_limit']);	
	if(!empty($input['rl_before_list'])) $input['rl_before_list'] = addslashes($input['rl_before_list']);	
	if(!empty($input['rl_before_post_title'])) $input['rl_before_post_title'] = addslashes($input['rl_before_post_title']);
	if(!empty($input['rl_after_post_title'])) $input['rl_after_post_title'] = addslashes($input['rl_after_post_title']);
	if(!empty($input['rl_before_post_excerpt'])) $input['rl_before_post_excerpt'] = addslashes($input['rl_before_post_excerpt']);
	if(!empty($input['rl_after_post_excerpt'])) $input['rl_after_post_excerpt'] = addslashes($input['rl_after_post_excerpt']);
	if(!empty($input['rl_before_list_item'])) $input['rl_before_list_item'] = addslashes($input['rl_before_list_item']);
	if(!empty($input['rl_after_list_item'])) $input['rl_after_list_item'] = addslashes($input['rl_after_list_item']);
	if(!empty($input['rl_after_list'])) $input['rl_after_list'] = addslashes($input['rl_after_list']);

	return $input;
}

/**
 * admin options, set default values if empty
 **/
function seo_alrp_get_admin_options(){
	$options = array(
		  'al_enabled' => 1,					 
		  'al_limit' => 1,
		  'al_match_limit' => 100,
		  'al_meta_keyword' => 1,
		  'al_link_title' => 'See also #title',
		  'al_manual_link' => "WordPress,http://wordpress.org,nofollow\nWikipedia,http://wikipedia.org",
		  'rl_enabled' => 1,
		  'rl_limit' => 5,
		  'rl_exc_cat' => '',
		  'rl_on_pages' => 0,	
		  'rl_add_content' => 1,
		  'rl_add_feed' => 1,	  
		  'rl_match_content' => 1,
		  'rl_title' => '<h2>Posts Related to #post_title</h2>',
		  'rl_excerpt' => 1,
		  'rl_excerpt_len' => 25,
		  'rl_404_limit' => 10,
		  'rl_blank_output' => '<p>There are no posts related to #post_title.</p>',
		  'rl_before_list' => '<ul>',
		  'rl_before_list_item' => '<li>',
		  'rl_before_post_title' => '<h3>',
		  'rl_after_post_title' => '</h3>',
		  'rl_before_post_excerpt' => '<p>',
		  'rl_after_post_excerpt' => '</p>',		  
		  'rl_after_list_item' => '</li>',
		  'rl_after_list' => '</ul>'	  
	  );
	$current_options = get_option('seo_alrp_options');
	if (!empty($current_options)) {
	  foreach ($current_options as $key => $option)
		$options[$key] = $option;
	}
	update_option('seo_alrp_options', $options);
	return $options;
}

/**
 * framework to handle the admin form
**/ 
function pk_seo_alrp_admin_menu(){	
	pk_seo_alrp_admin_print_admin_page();	
}
/**
 * print admin page
**/
function pk_seo_alrp_admin_print_admin_page(){
?>
<style type="text/css">
.inside p {
	margin: 14px;
}
.inside .frame {
	margin: 10px;
}
</style>
<div class = "wrap">
  <div class="icon32" id="icon-options-general"> <br>
  </div>
  <h2>
    <?php _e('SEO Auto Links &amp; Related Posts','seo-alrp'); ?>
  </h2>
  <div>
    <p> If you think this plugin useful, please consider making a <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=X66PFX355A9H4" target="_blank">donation</a> or write a review about it or at least give it a good rating on <a href="http://wordpress.org/extend/plugins/seo-alrp/" target="_blank">WordPress.org</a>.</p>
  </div>
  <div class="postbox-container" style="width: 100%;">
    <div class="metabox-holder">
      <div class="meta-box-sortables ui-sortable">
        <form id="seo-alrp-options" method="post" action="options.php">
          <?php //delete_option('seo_alrp_options'); ?>
          <?php settings_fields('seo-alrp'); ?>
          <?php $options = seo_alrp_get_admin_options(); ?>
          <div id="seo_alrp_new" class="postbox">
            <div class="handlediv"> <br />
            </div>
            <h3 class="hndle"> <span> What's New in Version 0.110323? </span></h3>
            <div class="inside">
              <div class="frame">
                <ol>
                  <li>Auto link meta keyword found inside the blog post.</li>
                  <li>Related posts now is based on post title, post content, and meta keyword.</li>
                  <li>Related posts for 404 error page.</li>
                  <li>Exclude category from related posts.</li>
                </ol>
              </div>
            </div>
          </div>
          <div id="seo_alrp_auto_links_settings" class="postbox">
            <div class="handlediv"> <br />
            </div>
            <h3 class="hndle"> <span> SEO Auto Links Settings </span></h3>
            <div class="inside">
              <div class="frame">
                <table class="form-table">
                  <tbody>
                    <tr valign="top">
                      <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[al_enabled]" id="seo_alrp_options[al_enabled]" value="1" <?php if (1==$options['al_enabled']) echo 'checked' ?> />
                        <label for="seo_alrp_options[al_enabled]">
                          <?php _e('Enabled auto links.','seo-alrp'); ?>
                        </label>
                      </th>
                    </tr>
                    <tr valign="top">
                      <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[al_meta_keyword]" id="seo_alrp_options[al_meta_keyword]" value="1" <?php if (1==$options['al_meta_keyword']) echo 'checked' ?> />
                        <label for="seo_alrp_options[al_meta_keyword]">
                          <?php _e('Auto link <strong>meta keyword</strong>. When the meta keywords and post title found in a blog post, it will automatically converted into internal links. If unchecked, only post title will be used.','seo-alrp'); ?>
                        </label>
                      </th>
                    </tr>                               
                    <tr valign="top">
                      <th scope="row" style="width:30%"><label for="seo_alrp_options[al_limit]">
                          <?php _e('Number of auto links per keyword: ','seo-alrp'); ?>
                        </label></th>
                      <td><input type="text" name="seo_alrp_options[al_limit]" id="seo_alrp_options[al_limit]" size="5" value="<?php echo $options['al_limit']; ?>">
                        <?php _e('Defaults to 1 internal link per keyword. Use -1 for no limit.','seo-alrp'); ?></td>
                    </tr>
                    <tr valign="top">
                      <th scope="row"><label for="seo_alrp_options[al_match_limit]">
                          <?php _e('Number of related posts to be compared: ','seo-alrp'); ?>
                        </label></th>
                      <td><input type="text" name="seo_alrp_options[al_match_limit]" id="seo_alrp_options[al_match_limit]" size="5" value="<?php echo $options['al_match_limit']; ?>">
                        <?php _e('This plugin will compare post title and meta keyword that related to the blog post with the post content. A larger number means more comparisons to be done.','seo-alrp'); ?></td>
                    </tr>                                                 
                    <tr valign="top">
                      <th scope="row"><label for="seo_alrp_options[al_link_title]">
                          <?php _e('Format of the link title: ','seo-alrp'); ?>
                        </label></th>
                      <td><input type="text" size="50" name="seo_alrp_options[al_link_title]" id="seo_alrp_options[al_link_title]" value="<?php echo stripslashes($options['al_link_title']); ?>">
                        <br />
                        <?php _e('Use <i>#title</i> to use the title of the related post inside the link title. e.g: <code>&lt;a href="#" title="See also #title"&gt;keyword&lt;/a&gt;</code>','seo-alrp'); ?></td>
                    </tr>
                    <tr valign="top">
                      <th scope="row"><label for="seo_alrp_options[al_manual_link]">
                          <?php _e('Manual convert keywords into link: ','seo-alrp'); ?>
                        </label>
                      </th>
                      <td><textarea id="seo_alrp_options[al_manual_link]" name="seo_alrp_options[al_manual_link]" cols="75" rows="5" ><?php echo stripslashes( $options['al_manual_link'] ); ?></textarea>
                        <br />
                        <?php _e('Separate the <i>keyword,URL,nofollow</i> with a comma. Put only one URL per line and you don\'t have to put dofollow in it. You can use internal link or external affiliate link in here.'); ?></td>
                  </tbody>
                </table>
                <p>
                  <input class="button-primary" type="submit" name="seo_alrp_save" id="seo_alrp_save" value="Save Options" />
                </p>
              </div>
            </div>
          </div>
          <div id="seo_alrp_related_posts_settings" class="postbox">
            <div class="handlediv"> <br />
            </div>
            <h3 class="hndle"> <span> SEO Related Posts Settings </span></h3>
            <div class="inside">
              <div class="frame">
                <table class="form-table">
                  <tr valign="top">
                    <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[rl_enabled]" id="seo_alrp_options[rl_enabled]" value="1" <?php if (1==$options['rl_enabled']) echo 'checked' ?> />
                      <label for="seo_alrp_options[rl_enabled]">
                        <?php _e('Enabled related posts.','seo-alrp'); ?>
                      </label>
                    </th>
                  </tr>
                  <tr valign="top">
                    <th scope="row" style="width:30%"><label for="seo_alrp_options[rl_limit]">
                        <?php _e('Number of related posts: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_limit]" id="seo_alrp_options[rl_limit]" size="5" value="<?php echo $options['rl_limit']; ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_exc_cat]">
                        <?php _e('Categories to be excluded: ','seo-alrp'); ?>
                      </label></th>
                    <td><textarea cols="50" rows="2" id="seo_alrp_options[rl_exc_cat]" name="seo_alrp_options[rl_exc_cat]"><?php echo $options['rl_exc_cat']; ?></textarea>
                    <br />
                      <?php _e('Separate each category name with a comma.','seo-alrp'); ?></td>
                  </tr>
                    <tr valign="top">
                    <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[rl_on_pages]" id="seo_alrp_options[rl_on_pages]" value="1" <?php if (1==$options['rl_on_pages']) echo 'checked' ?> />
                      <label for="seo_alrp_options[rl_on_pages]">
                        <?php _e('Show related posts on pages. If not selected, then the related posts will be appeared on single posts only.','seo-alrp'); ?>
                      </label>
                    </th>
                  </tr>                  
                  <tr valign="top">
                    <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[rl_add_content]" id="seo_alrp_options[rl_add_content]" value="1" <?php if (1==$options['rl_add_content']) echo 'checked' ?> />
                      <label for="seo_alrp_options[rl_add_content]">
                        <?php _e('Automaticall add related posts after post content. If uncheck, please use this code to manually add the related posts to your template: <code>&lt;?php if(function_exists(\'seo_alrp\')) seo_alrp(); ?&gt;</code>.','seo-alrp'); ?>
                      </label>
                    </th>
                  </tr>
                  <tr valign="top">
                    <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[rl_add_feed]" id="seo_alrp_options[rl_add_feed]" value="1" <?php if (1==$options['rl_add_feed']) echo 'checked' ?> />
                      <label for="seo_alrp_options[rl_add_feed]">
                        <?php _e('Automaticall add related posts into blog feed.','seo-alrp'); ?>
                      </label>
                    </th>
                  </tr>
                  <tr valign="top">
                    <th class="th-full" colspan="2" scope="row"> <input type="checkbox" name="seo_alrp_options[rl_match_content]" id="seo_alrp_options[rl_match_content]" value="1" <?php if (1==$options['rl_match_content']) echo 'checked' ?> />
                      <label for="seo_alrp_options[rl_match_content]">
                        <?php _e('Also use <strong>post content</strong> to find the related posts. If unchecked, only <strong>post title AND meta keyword</strong> will be use to find the related posts.','seo-alrp'); ?>
                      </label>
                    </th>
                  </tr>
                  <tr valign="top">
                    <th scope="row" colspan="2" class="th-full"><h4>Output</h4></th>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_title]">
                        <?php _e('Related posts title: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" size="50" name="seo_alrp_options[rl_title]" id="seo_alrp_options[rl_title]" value="<?php echo stripslashes($options['rl_title']); ?>">
                      <br />
                      <?php _e('Use <i>#post_title</i> to use blog post title inside the related posts title.','seo-alrp'); ?></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_blank_output]">
                        <?php _e('No related posts message: ','seo-alrp'); ?>
                      </label>
                    </th>
                    <td><input type="text" size="55" name="seo_alrp_options[rl_blank_output]" id="seo_alrp_options[rl_blank_output]" value="<?php echo stripslashes($options['rl_blank_output']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th colspan="2" scope="row" class="th-full"> <input type="checkbox" name="seo_alrp_options[rl_excerpt]" id="seo_alrp_options[rl_excerpt]" value="1" <?php if (1==$options['rl_excerpt']) echo 'checked' ?> />
                      <label for="seo_alrp_options[rl_excerpt]">
                        <?php _e('Display post excerpt.','seo-alrp'); ?>
                      </label>
                    </th>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_excerpt_len]">
                        <?php _e('Excerpt length (in words): ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_excerpt_len]" id="seo_alrp_options[rl_excerpt_len]" size="5" value="<?php echo $options['rl_excerpt_len']; ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row" colspan="2" class="th-full"><h4>Related posts in 404 page</h4></th>
                  </tr>
					<tr valign="top">
                    <th scope="row" style="width:30%"><label for="seo_alrp_options[rl_404_limit]">
                        <?php _e('Number of 404 related posts: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_404_limit]" id="seo_alrp_options[rl_404_limit]" size="5" value="<?php echo $options['rl_404_limit']; ?>"></td>
                  </tr>                  
  					<tr valign="top">
                    <th scope="row" colspan="2" class="th-full"><?php _e('Edit your 404.php template file, then add this code to display related posts base on the URI: <code>&lt;?php if(function_exists(\'seo_alrp_404\')) seo_alrp_404(); ?&gt;</code>','seo-alrp'); ?></th>
                    </tr>                  
  					<tr valign="top">
                    <th scope="row" colspan="2" class="th-full"><?php _e('To display the title of error 404 page, use this following code: <code>&lt;?php if(function_exists(\'seo_alrp_404_title\')) seo_alrp_404_title(); ?&gt;</code>','seo-alrp'); ?></th>
                  	</tr>                  
                  <tr valign="top">
                    <th scope="row" colspan="2" class="th-full"><h4>HTML Tag</h4></th>
                  </tr>
                  <tr valign="top">
                    <th scope="row">Default format:</th>
                    <td><code>&lt;ul&gt;<br />
                      &nbsp;&nbsp;&nbsp;&lt;li&gt;<br />
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;h3&gt;Post title&lt;/h3&gt;<br />
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;p&gt;Post excerpt&lt;/p&gt;<br />
                      &nbsp;&nbsp;&nbsp;&lt;/li&gt;<br />
                      &lt;/ul&gt;</code></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_before_list]">
                        <?php _e('Before the list of posts: ','seo-alrp'); ?>
                      </label>
                    </th>
                    <td><input type="text" name="seo_alrp_options[rl_before_list]" id="seo_alrp_options[rl_before_list]" value="<?php echo stripslashes($options['rl_before_list']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_before_list_item]">
                        <?php _e('Before each list item: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_before_list_item]" id="seo_alrp_options[rl_before_list_item]" value="<?php echo stripslashes($options['rl_before_list_item']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_before_post_title]">
                        <?php _e('Before post title: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_before_post_title]" id="seo_alrp_options[rl_before_post_title]" value="<?php echo stripslashes($options['rl_before_post_title']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_after_post_title]">
                        <?php _e('After post title: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_after_post_title]" id="seo_alrp_options[rl_after_post_title]" value="<?php echo stripslashes($options['rl_after_post_title']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_before_post_excerpt]">
                        <?php _e('Before post excerpt: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_before_post_excerpt]" id="seo_alrp_options[rl_before_post_excerpt]" value="<?php echo stripslashes($options['rl_before_post_excerpt']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_after_post_excerpt]">
                        <?php _e('After post excerpt: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_after_post_excerpt]" id="seo_alrp_options[rl_after_post_excerpt]" value="<?php echo stripslashes($options['rl_after_post_excerpt']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_after_list_item]">
                        <?php _e('After each list item: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_after_list_item]" id="seo_alrp_options[rl_after_list_item]" value="<?php echo stripslashes($options['rl_after_list_item']); ?>"></td>
                  </tr>
                  <tr valign="top">
                    <th scope="row"><label for="seo_alrp_options[rl_after_list]">
                        <?php _e('After the list of posts: ','seo-alrp'); ?>
                      </label></th>
                    <td><input type="text" name="seo_alrp_options[rl_after_list]" id="seo_alrp_options[rl_after_list]" value="<?php echo stripslashes($options['rl_after_list']); ?>"></td>                  
                  </tbody>
                  
                </table>
                <p>
                  <input class="button-primary" type="submit" name="seo_alrp_save" id="seo_alrp_save" value="Save Options" />
                </p>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
  <div class="postbox-container" style="width: 100%;">
    <div class="metabox-holder">
      <div id="seo-alrp-copyright" class="postbox">
        <div class="inside">
          <div class="frame" style="text-align:center">
            <p><strong>Recommended SEO plugins: <a href="http://9cab9omg4qgd8r98wbjl1jucfe.hop.clickbank.net/?tid=alrp" target="_blank">Indexing Tool</a> | <a href="http://ed94dfjezefg9u0nhg0qgewkvu.hop.clickbank.net/?tid=alrp" target="_blank">SEOPressor</a> | <a href="http://5508coi61qlh0mco1k9jkcqk4z.hop.clickbank.net/?tid=alrp" target="_blank">WPSyndicator</a></strong></p>
            <p>Copyright &copy; 2011 by Purwedi Kurniawan. Feel free to <a href="http://exclusivewordpress.com/contact/" target="_blank">contact me</a> if you need help with the plugin.</p>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
</div>
<?php 
}

/**
 * display related posts
**/
function seo_alrp_get_related_posts( $options = '', $err_search_term = '' ) {
	global $wpdb, $post, $single;

	if ( empty($options) ) $options = get_option('seo_alrp_options');

	$limit = (stripslashes($options['rl_limit']));
	
	$time_difference = get_settings('gmt_offset');
	$now = gmdate("Y-m-d H:i:s",(time()+($time_difference*3600)));	
	
	$sql_title = addslashes($post->post_title);
	if( !empty( $err_search_term ) ){
		$content_ok	= addslashes(pk_seo_alrp_tokenize_stopwords(strip_tags($err_search_term)));
		$sql_title = $err_search_term;
	} elseif ( !empty($options['rl_match_content']) ) {
		$content_ok = strip_tags($post->post_content);
		$content_ok = addslashes($post->post_title. ' ' . $content_ok );		
	} else {
		$content_ok = addslashes($post->post_title);
	}
	
	if( !empty( $err_search_term ) ){
		$cache_key = 'seo_alrp_rl_404_'.$err_search_term;
		$searches = wp_cache_get( $cache_key );
		if ( false == $searches ) {					
			$search_counter = 0;
			
			$sql_exc_cats = pk_seo_alrp_excluded_cats ( $options['rl_exc_cat'] );
		
			$searches = $wpdb->get_results( $wpdb->prepare( "SELECT ID, post_title, post_date, post_content, 
				CASE WHEN post_title LIKE '%%%s%%' THEN 1 ELSE 0 END AS title_score,
				MATCH (post_title, post_content) AGAINST ('%s') AS score
				FROM $wpdb->posts
				WHERE MATCH (post_title, post_content) AGAINST ('%s' IN BOOLEAN MODE) 
				AND post_status = 'publish'
				AND post_date <= '%s'			
				AND post_type = 'post'                
				$sql_exc_cats
				ORDER BY ( title_score * 5 + score ) DESC
				LIMIT %d",$sql_title, $content_ok, $content_ok, $now, $options['rl_404_limit'] ) );
				
			//echo 'Related post query: '. $wpdb->last_query . '<br /><br />';
			
			wp_cache_set( $cache_key, $searches );			
		} 	
	} else {
		$meta_keywords = get_post_meta($post->ID, 'keywords', true);
		if ( !empty($meta_keywords) ) $content_ok = addslashes($meta_keywords .' '. $content_ok);
		$content_ok = pk_seo_alrp_tokenize_stopwords( $content_ok );
		
		if (( is_int($post->ID) )&&( !empty($content_ok) )) {
			
			$cache_key = 'seo_alrp_rl_'.$post->ID;
			$searches = wp_cache_get( $cache_key );
			if ( false == $searches ) {					
				$search_counter = 0;
				
				$sql_exc_cats = pk_seo_alrp_excluded_cats ( $options['rl_exc_cat'] );
		
				$searches = $wpdb->get_results( $wpdb->prepare( "SELECT ID, post_title, post_date, post_content, 
					CASE WHEN post_title LIKE '%%%s%%' THEN 1 ELSE 0 END AS title_score,
					MATCH (post_title, post_content) AGAINST ('%s') AS score
					FROM $wpdb->posts
					WHERE MATCH (post_title, post_content) AGAINST ('%s' IN BOOLEAN MODE) 
					AND post_content != '%s' 
					AND post_status = 'publish'
					AND ID != %d
					AND post_date <= '%s'			
					AND post_type = 'post'                
					$sql_exc_cats
					ORDER BY ( title_score * 5 + score ) DESC
					LIMIT %d",$sql_title, $content_ok, $content_ok, $post->post_content, $post->ID, $now, $options['rl_limit'] ) );
					
				//echo 'Related post query: '. $wpdb->last_query . '<br /><br />';
				
				wp_cache_set( $cache_key, $searches );			
			} 	
		
		} else {
			$searches = false;
		}
	}
	
	$output = '';
	if( $searches ){		
		if( !empty( $err_search_term ) ){
			$rl_title = str_replace('#post_title',ucwords($err_search_term),$options['rl_title']);
		} else {
			$rl_title = str_replace('#post_title',$post->post_title,$options['rl_title']);
		}
		$output .= (stripslashes($rl_title));
		$output .= $options['rl_before_list'];
        $permalink = get_permalink( $post->ID );
		$prev_post_content = '';
		foreach( $searches as $search ) {
			$title = get_the_title($search->ID);
			if ( $prev_post_content != $search->post_content ){
				$prev_post_content = $search->post_content;
				$output .= $options['rl_before_list_item'];
				$output .= $options['rl_before_post_title'].'<a href="'.get_permalink($search->ID).'" rel="bookmark">'.$title.'</a>'.$options['rl_after_post_title'];
				if ( $options['rl_excerpt']) {
					$output .= $options['rl_before_post_excerpt'].pk_seo_alrp_excerpt($search->post_content,$options['rl_excerpt_len']).$options['rl_after_post_excerpt'];
				}
				$output .= $options['rl_after_list_item'];
				$search_counter++; 
			}
			if ($search_counter == $limit) break;
		} 
		$output .= $options['rl_after_list'];
		$output = '<div id="seo_alrp_related">'.$output.'</div>';
	} else {
		$output = str_replace('#post_title', $post->post_title, $options['rl_blank_output']); 
	}
	
	return $output;
}

/**
 * auto add related posts to content or feed
**/
add_filter('the_content', 'seo_alrp_content', 10);
function seo_alrp_content($content) {
	$options = get_option('seo_alrp_options');
	if( $options['rl_enabled'] ){
        if ( ( is_page() && $options['rl_on_pages'] && $options['rl_add_content'] ) || ( is_single() && $options['rl_add_content'] ) ) {
			$output = seo_alrp_get_related_posts( $options );
			$content .= $output;
		} elseif( (is_feed() ) && ( $options['rl_add_feed'] ) ) {
			$output = seo_alrp_get_related_posts( $options );
			$content .= $output;
		} 
	}
    return $content;
}

/**
 * echoing related posts
**/
function seo_alrp() {
	$output = seo_alrp_get_related_posts();
	echo $output;
}

/**
 * return post excerpt
 **/
function pk_seo_alrp_excerpt($text, $excerpt_length) {

	if ( !empty( $text ) ) {
		$text = strip_shortcodes( $text );
		$text = str_replace(']]>', ']]&gt;', $text);
		$text = strip_tags($text);
		$words = preg_split("/[\n\r\t ]+/", $text, $excerpt_length + 1, PREG_SPLIT_NO_EMPTY);
		if ( count($words) > $excerpt_length ) {
			array_pop($words);
			$text = implode(' ', $words);
			$text = $text . ' ...';
		} else {
			$text = implode(' ', $words);
		}
	}
	return $text;
}

/**
 * import stopwords from file, and remove all occurences from post content
 **/
function pk_seo_alrp_tokenize_stopwords( $content ){
	include dirname( __FILE__ ) . '/stopwords.php';
	$content = preg_replace("/[^a-zA-Z\s]/", "", strtolower( $content ));
	$acontent = explode ( ' ', $content );
	$tokenized = '';
	foreach ( $acontent as $str ){
		$tokenized .= ( !in_array( $str, $stopwords ) && strlen( $str ) > 3 ) ? $str . ' ' : '';
	}
	return $tokenized;
}

/**
 * automatically create link to related posts,
 **/
add_filter('the_content','pk_seo_alrp_auto_link_content_filter', 0);
function pk_seo_alrp_auto_link_content_filter( $content ){

	$options = get_option('seo_alrp_options');
	if ( is_single() && $options['al_enabled'] ){		
		global $post, $wpdb;
		$cache_key = 'pk_seo_al_'.$post->ID;
		$searches = wp_cache_get( $cache_key );
		if ( false == $searches ) {						
			$time_difference = get_settings('gmt_offset');
			$now = gmdate("Y-m-d H:i:s",(time()+($time_difference*3600)));

			$content_ok = pk_seo_alrp_tokenize_stopwords( strip_tags($content) );
				
			$searches = $wpdb->get_results($wpdb->prepare( "SELECT ID, post_title, 
				MATCH (post_title, post_content) AGAINST ('%s') AS score
				FROM $wpdb->posts
				WHERE MATCH (post_title, post_content) AGAINST ('%s' IN BOOLEAN MODE) 
				AND post_status = 'publish'
				AND post_date <= '%s'			
				AND post_type = 'post'
				ORDER BY score DESC
				LIMIT %d;", $content_ok, $content_ok, $now, $options['al_match_limit'] ));

			//echo 'Auto links query: '. $wpdb->last_query . '<br /><br />' . 'Num Rows: '. $wpdb->num_rows . '<br /><br />';				
			wp_cache_set( $cache_key, $searches, 7776000 );			
		} 	

		if ( false != $searches ) {	
			foreach($searches as $search) {
				$pos = stripos( $content, $search->post_title );
				if ( 0 <= $pos ){ //if title found in post content
					$permalink = get_permalink( $search->ID );
					$link_title = str_replace('#title', $search->post_title, $options['al_link_title']);
					
					//echo '<br />POST TITLE: '.$search->post_title;
					
					if ($options['al_meta_keyword']){
					
                        $keywords = '';
                        $meta_keywords = get_post_meta($search->ID, 'keywords', true);
                        if (!empty($meta_keywords)){
                            $a_keywords = explode(',', $meta_keywords);
                            foreach ( $a_keywords as $keyword ) {
                                $keywords .= trim( preg_quote( $keyword, '/' ), ', ').'|';
                            }
                        }
                        
                        $keywords .= preg_quote( $search->post_title, '/');
                        $keywords = trim( $keywords, ' ,|');
					} else {
					   $keywords = preg_quote( $search->post_title, '/') ;
                    }									
					
					$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.$keywords.')\b/imsU';							
					$replace = "<a title=\"$link_title\" href=\"$permalink\">\$0</a>";

					$content = preg_replace( $regexp, $replace , $content, $options['al_limit'] );
					
					$seo_alrp_check_plural = false;
					if ( $seo_alrp_check_plural ){
						$s = substr( $search->post_title, - 1);
						$s2 = substr( $search->post_title, - 2);
						if ( 'e' == $s ){
							$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote($search->post_title.'s', '/').')\b/imsU';
						} elseif ( 'is' == $s2 ){
							$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote(substr( $search->post_title, 0, strlen($search->post_title) - 2 ).'es', '/').')\b/imsU';						
						} elseif ( 'y' == $s ){
							$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote(substr( $search->post_title, 0, strlen($search->post_title) - 1 ).'ies', '/').')\b/imsU';
						} elseif ( 'f' == $s | 'fe' == $s2){
							$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote(substr( $search->post_title, 0, strlen($search->post_title) - 1 ).'ves', '/').')\b/imsU';
						} elseif ( 's' == $s | 'x' == $s | 'ch' == $s2 | 'z' == $s | 'o' == $s | 'sh' == $s2 ){
							$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote($search->post_title.'es', '/').')\b/imsU';
						} else {
							$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote($search->post_title.'s', '/').')\b/imsU';
						}							
						
						$content = preg_replace( $regexp, $replace , $content, $options['al_limit'] );		
					}
					
				}
			}
		}
		
		$content = pk_seo_alrp_manual_auto_links($content, $options);
	}
	return $content;
}

/**
 * manual auto link
 **/
function pk_seo_alrp_manual_auto_links($content, $options){
	if (!empty($options['al_manual_link'])){
		$autolinks = explode("\n",$options['al_manual_link']);
		
		foreach ( $autolinks as $autolink ){
			$links = explode(',',trim($autolink));
			$nofollow = (3==count($links)) ? 'rel="'.$links[2].'"' : '';
			$regexp = '/(?!(?:[^<\[]+[>\]]|[^>\]]+<\/a>))\b('.preg_quote($links[0], '/').')\b/imsU';
			$replace = "<a title=\"".$links[0]."\" href=\"".$links[1]."\" $nofollow>\$0</a>";
			$content = preg_replace( $regexp, $replace , $content, $options['al_limit'] );
		}
	}
	return $content;
}

/**
 * also known as aka synonym feature
 **/
function pk_seo_also_known_as(){
	global $post, $wpdb;
	
	$cache_key = 'pk_seo_aka_'.$post->ID;
	$aka = wp_cache_get( $cache_key );
	if ( false == $aka ) {		
		$aka = $wpdb->get_results( $wpdb->prepare( "SELECT post_title
			FROM $wpdb->posts
			WHERE post_status = 'publish'
			AND post_content = '%s' 
			AND ID != %d
			LIMIT 25;", $post->post_content, $post->ID ));
		wp_cache_set( $cache_key, $aka );		
	}
	
	$ret = '';
	if ( false != $aka ){
		foreach ($aka as $key){
			$ret .= $key->post_title.', ';
		}
		$ret = strtolower (trim ($ret, ', '));
	}	
	return $ret;
}

/** 
 * exclude certain category from related posts
 **/
function pk_seo_alrp_excluded_cats($excluded_cats) {
	global $wpdb;
	$catarray = explode(',', $excluded_cats);
	$cats = '';
	foreach ( $catarray as $cat ) {
		$cats .= get_cat_id($cat).',';
	}
	$cats = trim($cats,',');
	$catarray = explode(',', $cats);
	foreach ( $catarray as $cat ) {
		$catarray = array_merge($catarray, get_term_children($cat, 'category'));
	}
	$catarray = array_unique($catarray);
	$ids = get_objects_in_term($catarray, 'category');
	if ( is_array($ids) && count($ids) > 0 ) {
		$out_posts = "'" . implode("', '", $ids) . "'";
		$sql = " AND $wpdb->posts.ID NOT IN ($out_posts) ";
	} else {
		$sql = " AND 1 = 1 ";
	}
	return $sql;
} 

/**
 * related posts on error page 404
 **/
function seo_alrp_404() {
   	$search_term = seo_alrp_get_404_title();
	echo seo_alrp_get_related_posts ( '', $search_term );
}

/**
 * get error page 404 title
 **/
function seo_alrp_get_404_title(){
	$basename = str_replace(array('.php','.html','.htm'),'',basename($_SERVER['REQUEST_URI']));
	$search = array ('@[\/]+@', '@(\..*)@', '@[\-]+@', '@[\_]+@', '@[\s]+@', '@archives@','@(\?.*)@','/\d/');
	$replace = array (' ', '', ' ', ' ', ' ', '', '','');
	$search_term = preg_replace($search, $replace, $basename);
	$search_term = trim($search_term);	
	return $search_term;
}

function seo_alrp_404_title(){
	echo ucwords(seo_alrp_get_404_title());
}
?>